/*
 * Decompiled with CFR 0.152.
 */
package fire.pb.scene;

import fire.pb.scene.Scene;
import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class MonsterInfo {
    private int mapID = 0;
    private int width = 0;
    private int highth = 0;
    private final Map<Integer, Integer> infos = new HashMap<Integer, Integer>();
    private final int MIN_FILE_SIZE = 16;
    private final Map<Integer, Set<Pos>> monstershowArea = new HashMap<Integer, Set<Pos>>();

    MonsterInfo(int mapID) {
        this.mapID = mapID;
    }

    public int getMonsterConfig(int x, int y) {
        Integer ret = this.infos.get((x << 16) + y);
        if (null == ret) {
            return 0;
        }
        return ret;
    }

    public void load() {
        String fileName = this.getFileName();
        File f = new File(fileName);
        if (!f.exists()) {
            return;
        }
        try {
            DataInputStream in = new DataInputStream(new BufferedInputStream(new FileInputStream(fileName)));
            int headLen = Integer.reverseBytes(in.readInt());
            if (headLen != this.MIN_FILE_SIZE) {
                in.close();
                throw new Exception("初始化地图文件大小错误");
            }
            this.width = Integer.reverseBytes(in.readInt());
            this.highth = Integer.reverseBytes(in.readInt());
            if (this.width < 1 || this.highth < 1) {
                in.close();
                throw new Exception("初始化布怪文件数值错误");
            }
            int count = Integer.reverseBytes(in.readInt());
            for (int i = 0; i < count; ++i) {
                int pos = Integer.reverseBytes(in.readInt());
                int val = Integer.reverseBytes(in.readInt());
                this.infos.put(pos, val);
                if (val >= 0) continue;
                int pos_x = pos >>> 16;
                int pos_y = pos & 0xFFFF;
                Set<Pos> area = this.monstershowArea.get(-val);
                if (area == null) {
                    area = new HashSet<Pos>();
                    this.monstershowArea.put(-val, area);
                }
                area.add(new Pos(pos_x, pos_y));
            }
            in.close();
        }
        catch (Exception e) {
            Scene.LOG.info((Object)e);
        }
    }

    private String getFileName() {
        return "gamedata/map/" + this.mapID + "/monster.dat";
    }

    public Map<Integer, Set<Pos>> getMonstershowArea() {
        return this.monstershowArea;
    }

    public class Pos {
        public final int x;
        public final int y;

        public Pos(int x, int y) {
            this.x = x;
            this.y = y;
        }
    }
}

